SystemOrganization addCategory: #LandSlide!

WAComponent subclass: #DocumentationHolder
	instanceVariableNames: 'classes methods decls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!DocumentationHolder commentStamp: '<historical>' prior: 0!
I hold all the information for rendering the contents of the Monticello project that was loaded.

Instance Variables
	classes:		<OrderedList>
	methods:		<OrderedList>

classes
	- The list of classes processed in the package

methods
	- The list of methods preocessed in the package
!

!DocumentationHolder class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/7/2013 17:40'!
withClasses: classes
	^ (self new classes: classes)! !

!DocumentationHolder class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
withClasses: classes andMethods: methods
	^ (self new classes: classes) methods: methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:01'!
activateEditorScript
	"This is a quick javascript snippet to set the accordion height"
	^ ' 
$(".ui-accordion-content").each(
	function() { 
		$(this).css("height", "auto") 
	} 
)
'! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:36'!
classes
	" Answers with an OrderedCollection of ClassDocumentation"
	^classes! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:02'!
classes: theClasses
	"Sets the classes to be with theClasses"
	classes := theClasses! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:02'!
decls
	"Answers with the decls that this documentation holder holds"
	^ decls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:02'!
decls: theDecls
	"Sets the decls this class stores with theDecls"
	decls := theDecls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:02'!
methods
	"Answers with all of the MethodNodes in this documentation"
	^methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:03'!
methods: theMethods
	"Sets all of the methods for this documentation"
	methods := theMethods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:42'!
renderContentOn: html
	html div
      	script: ((html jQuery new accordion) autoHeight: true);
		style: '';
      	with: [
			self classes do: [ :class  |
				html div: [ 
					html anchor: (class name). 
					(class classComment contents isEmpty ) 
						ifTrue: [ html preformatted: 'No class comment' ]
						ifFalse: [ html preformatted: (class classComment contents) ].
				].
				html div: [
					class methods do: [ :v |  
						v comment 
							ifNotNil: [ html paragraph: (v selector) , ' - ' , (v comment contents at: 1). ] 
								ifNil: [ html paragraph: (v selector) , ' - No Comment ' ] .
						html preformatted with: (v sourceCode).
						html break.
					]. 
				]
			 ] 
		] .
	html document addLoadScript: self activateEditorScript ! !

WAComponent subclass: #LandSlidePage
	instanceVariableNames: 'url holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlidePage commentStamp: '<historical>' prior: 0!
I am the home page displayed when the application is first loaded.

Instance Variables
	holder:		<DocumentationHolder>
	url:		<String>

holder
	- The DocumentationHolder for the Monticello project the user selectes.

url
	- The url to the Monticello project to be viewed.
!

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:59'!
buildDocumentation
	"Will go through and download the package and then also go through and parse it into a DocumentationHolder"
	| string pars |
	string := MonticelloUnpacker fromUrl: (self url) .
	pars := LandSlideParser  new .
	holder := pars parseString: string.
	! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:57'!
renderContentOn: html
	html heading: 'Lanslide'.
 	html form: [
      	html text: 'MCZ URL: '.
		html textInput
			callback: [ :value | self url: value ];
			value: (self url);
			size: 100.
		html break.
		html submitButton
			callback: [ self buildDocumentation ];
			value: 'Build Documentation'].
		holder ifNotNil: [  
			html div
				class: 'component';
				with: holder.
	]! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:59'!
style
	"Styled the CSS to make the format nice and neat"
	^'
body {
  font-family: Droid Sans, Arial, sans-serif;
  line-height: 1.5;
  max-width: 64.3em;
  margin: 3em auto;
  padding: 0 1em;

}

h1 {
  letter-spacing: -3px;
  font-size: 3.23em;
  font-weight: bold;
  margin: 0;
}

h2 {
  font-size: 1.23em;
  font-weight: bold;
  margin: .5em 0;
  letter-spacing: -1px;
}

h3 {
  font-size: 1em;
  font-weight: bold;
  margin: .4em 0;
}

pre {
  background-color: #eee;
  -moz-border-radius: 6px;
  -webkit-border-radius: 6px;
  border-radius: 6px;
  padding: 1em; 
  overflow: scroll;
  tab-size:      4;
}

pre.code {
  margin: 0 1em;
}

.grey {
  font-size: 2.2em;
  padding: .5em 1em;
  line-height: 1.2em;
  margin-top: .5em;
  position: relative;
}

img.logo {
  position: absolute;
  right: -25px;
  bottom: 4px;
}

a:link, a:visited, .quasilink {
  color: #df0019;
  cursor: pointer;
  text-decoration: none;
}

a:hover, .quasilink:hover {
  color: #800004;
}

h1 a:link, h1 a:visited, h1 a:hover {
  color: black;
}

ul {
  margin: 0;
  padding-left: 1.2em;
}

a.download {
  color: white;
  background-color: #df0019;
  width: 100%;
  display: block;
  text-align: center;
  font-size: 1.23em;
  font-weight: bold;
  text-decoration: none;
  -moz-border-radius: 6px;
  -webkit-border-radius: 6px;
  border-radius: 6px;
  padding: .5em 0;
  margin-bottom: 1em;
}

a.download:hover {
  background-color: #bb0010;
}

.rel {
  margin-bottom: 0;
}

.rel-note {
  color: #777;
  font-size: .9em;
  margin-top: .1em;
}

.logo-braces {
  color: #df0019;
  position: relative;
  top: -4px;
}

.blk {
  float: left;
}

.left {
  width: 37em;
  padding-right: 6.53em;
  padding-bottom: 1em;
}

.left1 {
  width: 15.24em;
  padding-right: 6.45em;
}

.left2 {
  width: 15.24em;
}

.right {
  width: 20.68em;
}

.leftbig {
  width: 42.44em;
  padding-right: 6.53em;
}

.rightsmall {
  width: 15.24em;
}

.clear:after {
  visibility: hidden;
  display: block;
  font-size: 0;
  content: " ";
  clear: both;
  height: 0;
}
.clear { display: inline-block; }
/* start commented backslash hack \*/
* html .clear { height: 1%; }
.clear { display: block; }
/* close commented backslash hack */
	'! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/7/2013 17:05'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.	
	anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css' .
	anHtmlRoot stylesheet url: 'http://code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css'.! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:00'!
url
	"Answers with the URL the user inputted"
	^url! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:00'!
url: newUrl
	"Sets the URL with the URL the user inputted"
	url := newUrl! !

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlideTest commentStamp: '<historical>' prior: 0!
I test the functionality of the LandSlide project.
!

!LandSlideTest methodsFor: 'tests' stamp: 'BillBindi 5/7/2013 18:41'!
testLandSLideParser
| parser str holder |
	parser := LandSlideParser new.
	str := 'SystemOrganization addCategory: #LandSlide!!

Object subclass: #MonticelloUnpacker

	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''LandSlide''!!

!!MonticelloUnpacker class methodsFor: ''as yet unclassified'' stamp: ''SeanHurley 4/17/2013 17:18''!!
getNewFileContents
	| file zip dir fileStream fileContents |
	file := StandardWindow new fileOpen: ''''.
	zip := ZipArchive new readFrom: (file fullName) .
	dir := FileSystem disk workingDirectory / ''temp''.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / ''snapshot'' / ''source.st'') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents!! !!

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''LandSlide''!!
'. 
	holder := parser parseString: str.
	
	self assert: ((holder classes at: 1) name = 'MonticelloUnpacker').
	self assert: ((holder classes at: 2) name = 'LandSlideTest')! !

!LandSlideTest methodsFor: 'tests' stamp: 'ArjunNayini 5/7/2013 18:53'!
testMonticelloUnpacker
	| actual expected |
	expected := 'SystemOrganization addCategory: #LandSlide!!

Object subclass: #MonticelloUnpacker
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''LandSlide''!!

!!MonticelloUnpacker class methodsFor: ''as yet unclassified'' stamp: ''SeanHurley 4/17/2013 17:18''!!
getNewFileContents
	| file zip dir fileStream fileContents |
	file := StandardWindow new fileOpen: '''' .
	zip := ZipArchive new readFrom: (file fullName) .
	dir := FileSystem disk workingDirectory / ''temp''.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / ''snapshot'' / ''source.st'') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents!! !!

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''LandSlide''!!
'. 
	actual := MonticelloUnpacker fromUrl: 'http://ss3.gemstone.com/ss/landslide/LandSlide-SeanHurley.3.mcz'.
	self assert: actual = expected
! !

!BehaviorInstallingDeclaration methodsFor: '*LandSlide' stamp: 'ChaseGeigle 5/7/2013 17:33'!
behaviorName
	^ behaviorName! !

Object subclass: #ClassDocumentation
	instanceVariableNames: 'methods classComment name superClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!ClassDocumentation commentStamp: '<historical>' prior: 0!
I hold information about the class and my super class.

Instance Variables
	methods:		<OrderedList>
	classComment:		<String>
	name:		<String>
	superClassName:		<String>
			
methods
	- A list of all the methods in the class.
	
classComment
	- The class comment for the class.
	
name
	- The name of the class.

superClassName
	- The name of the super class of the class.!

!ClassDocumentation class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:46'!
name: aString superClassName: anotherString
	^ ((self new) name: aString) superClassName: anotherString! !

!ClassDocumentation class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/7/2013 17:23'!
withName: aName andComment: aComment andMethods: aMethods
	^ ClassDocumentation new 
		name: aName; 
		comment: aComment; 
		methods: aMethods! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:03'!
classComment
	"Answers with the class comment for this class"
	^ classComment! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:03'!
classComment: aComment
	"Sets the class comment for this class"
	classComment := aComment! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:04'!
methods
	"Answers with an OrderedCollection of all of the MethodNodes this class contains"
	^ methods! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:04'!
methods: aMethods
	"Sets methods with an OrderedCollection of all of the MethodNodes this class contains"
	methods := aMethods! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:04'!
name
	"Answers with the name of this class"
	^ name! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:04'!
name: aString
	"Sets the name of this class"
	name := aString! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 17:00'!
printOn: aStream
	aStream nextPutAll: 'a ClassDocumentation(Name: '.
	aStream nextPutAll: name.
	aStream nextPutAll: ', Superclass: '.
	aStream nextPutAll: superClassName.
	aStream nextPutAll: ')'! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:04'!
superClassName
	"Answers with the name of this classes superclass"
	^ superClassName! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:05'!
superClassName: aString
	"Sets the name of this class's superclass"
	superClassName := aString! !

Object subclass: #LandSlideParser
	instanceVariableNames: 'parser subclassMessageSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlideParser commentStamp: '<historical>' prior: 0!
I am the parser that takes in the string representing the Monticello project and turn it into a list of its classes and methods.

Instance Variables
	parser:		<Parser>

parser
	- The object that parses the given string.
!

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/8/2013 11:52'!
gatherClasses: declarations
	| nodes doits messages classes |
	nodes := declarations 
		select: [ :decl | decl isKindOf: DoItDeclaration ]
		thenCollect: [ :decl | 
			[ parser 
				parse: (decl contents readStream) 
				class: UndefinedObject 
				noPattern: true 
				context: nil 
				notifying: nil 
				ifFail: [  ] ]
			on: UndeclaredVariableWarning 
			do: [ :ex | ex resume false ]
		].
	doits := nodes 
		select: [ :node | node selector == #DoIt ]
		thenCollect: [ :node | ((node block) statements at: 1) expr ].
	messages := doits
		select: [ :expr | (expr isKindOf: MessageNode) ].
	classes := messages 
		select: [ :expr | expr selector key = subclassMessageSymbol ]
		thenCollect: [ :expr | ClassDocumentation name: (((expr arguments at: 1) key) asString) superClassName: (expr receiver name) ].
	^ classes! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:16'!
gatherComments: declarations 
	| comments |
	comments := Dictionary new .
	declarations 
		select: [ :decl | decl isKindOf: ClassCommentDeclaration ]
		thenCollect: [ :decl | comments at: (decl behaviorName asString) put:decl ].
	^ comments! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/8/2013 11:43'!
gatherMethods: declarations
	| result node coll |
	result := Dictionary new.
	declarations 
			select: [ :decl | decl isKindOf: MethodDeclaration ]
			thenDo: [ :decl |
				[ node := parser parse: (decl contents readStream) class: UndefinedObject. ]
					on: UndeclaredVariableWarning
					do: [ :ex | ex resume:false ].
				result 
					at: (decl behaviorName asString)
					ifPresent: [ :list | list add: node ]
					ifAbsent: [ 
						coll := OrderedCollection new.
						coll add: node.
						result at: (decl behaviorName) put: coll 
					]
			].
	^ result! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/7/2013 18:10'!
initialize
	parser := Parser new.
	subclassMessageSymbol := #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 11:13'!
parseString: aString 
	| cffp declarations methods classes comments |
	"Parses a given file written in ChunkFileFormat, returning an object
	which represents the materials necessary for generating documentation"
	cffp := ChunkFileFormatParser for: (ReadStream on: aString).
	declarations := cffp parseDeclarations.
	methods := self gatherMethods: declarations.
	comments := self gatherComments: declarations .
	classes := self gatherClasses: declarations.
	classes do: [ :class | class methods: (methods at: (class name) ifPresent: [ :v | v ] ifAbsent: [ OrderedCollection new ]) ].
	classes do: [ :class | class classComment: (comments at: (class name) ifPresent: [ :v | v ] ifAbsent: [ '' ]) ].
	^ (DocumentationHolder withClasses: classes) decls: declarations.! !

Object subclass: #MonticelloUnpacker
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!MonticelloUnpacker commentStamp: '<historical>' prior: 0!
I am the reader that takes in a path to a Monticello project and turn it into a string.

Instance Variables
	filename:		<String>

filename
	- the name of the file that is the mcz of the Monticello project.
!

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:44'!
fromUrl: url
	"Passing a string url to a monticello project online this will download that 
	file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| dir znurl filename unpacker stringContents |
	dir := FileSystem disk workingDirectory .
	ZnClient new
		url: url;
		downloadTo:dir . 
	znurl := ZnUrl fromString: url .
	filename := znurl lastPathSegment .
	unpacker := (MonticelloUnpacker new)
		filename: (dir / filename) .
	stringContents := unpacker extractStringFromFile .
	unpacker cleanupFile .
	^stringContents! !

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:43'!
getNewFileContents
	"This will open a filepicker where the user can select a .mcz file and our unpacker
	will take that file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| file unpacker |
	file := StandardWindow new fileOpen: '' .
	unpacker := (MonticelloUnpacker new)  
		filename: file .
	^ unpacker extractStringFromFile ! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:05'!
cleanupFile
	"Cleans up the temporary file downloaded from monticello"
	self filename deleteAll! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:05'!
extractStringFromFile
	"This will actually take the filename used for this unpacker and extract it and return the contents of snapshot.st"
	| fulldir dir zip fileStream fileContents|
	fulldir := self filename .
	zip := ZipArchive new readFrom: (fulldir fullName) .
	dir := FileSystem disk workingDirectory / 'temp'.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / 'snapshot' / 'source.st') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:05'!
filename
	"Answers with the filename for the temporary file"
	^ filename! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/8/2013 12:05'!
filename: aFileName
	"Sets the temporary filename"
	filename := aFileName! !
